"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _path = _interopRequireDefault(require("../../../shared/lib/isomorphic/path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
class FileSystemCache {
    constructor(ctx){
        this.flushToDisk = ctx.flushToDisk;
        this.pagesDir = ctx.pagesDir;
        this.fs = ctx.fs;
    }
    async get(key) {
        return this.fs.readFile(this.getSeedPath(key));
    }
    async getMeta(key) {
        const stat = await this.fs.stat(this.getSeedPath(key));
        return {
            mtime: stat.mtime.getTime()
        };
    }
    async set(key, data) {
        if (!this.flushToDisk) return;
        const pathname = this.getSeedPath(key);
        await this.fs.mkdir(_path.default.dirname(pathname));
        return this.fs.writeFile(pathname, data);
    }
    getSeedPath(pathname) {
        return _path.default.join(this.pagesDir, pathname);
    }
}
exports.default = FileSystemCache;

//# sourceMappingURL=file-system-cache.js.map